/*
 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */


#define MAX_EVENT 34

static char *event_name[] = {

/*  0 */  "Error!",
/*  1 */  "A Reply",
/*  2 */  "KeyPress",
/*  3 */  "KeyRelease",
/*  4 */  "ButtonPress",
/*  5 */  "ButtonRelease",
/*  6 */  "MotionNotify",
/*  7 */  "EnterNotify",
/*  8 */  "LeaveNotify",
/*  9 */  "FocusIn",
/* 10 */  "FocusOut",
/* 11 */  "KeymapNotify",
/* 12 */  "Expose",
/* 13 */  "GraphicsExpose",
/* 14 */  "NoExpose",
/* 15 */  "VisibilityNotify",
/* 16 */  "CreateNotify",
/* 17 */  "DestroyNotify",
/* 18 */  "UnmapNotify",
/* 19 */  "MapNotify",
/* 20 */  "MapRequest",
/* 21 */  "ReparentNotify",
/* 22 */  "ConfigureNotify",
/* 23 */  "ConfigureRequest",
/* 24 */  "GravityNotify",
/* 25 */  "ResizeRequest",
/* 26 */  "CirculateNotify",
/* 27 */  "CirculateRequest",
/* 28 */  "PropertyNotify",
/* 29 */  "SelectionClear",
/* 30 */  "SelectionRequest",
/* 31 */  "SelectionNotify",
/* 32 */  "ColormapNotify",
/* 33 */  "ClientMessage",
/* 34 */  "MappingNotify"
};



/*
	Definition of X11 Requesting Protocols from Clients.
*/

static char *request_name[] = {

	/*000*/	 "NOT DEFINED",
	/*001*/	 "CreateWindow",
	/*002*/	 "ChangeWindowAttributes",
	/*003*/	 "GetWindowAttributes",
	/*004*/	 "DestroyWindow",
	/*005*/	 "DestroySubwindows",	
	/*006*/	 "ChangeSaveSet",
	/*007*/	 "ReparentWindow",
	/*008*/	 "MapWindow",	
	/*009*/	 "MapSubwindows",
	/*010*/	 "UnmapWindow",
	/*011*/	 "UnmapSubwindows",
	/*012*/	 "ConfigureWindow",
	/*013*/	 "CirculateWindow",
	/*014*/	 "GetGeometry",
	/*015*/	 "QueryTree",

	/*016*/	 "InternAtom",
	/*017*/	 "GetAtomName",
	/*018*/	 "ChangeProperty",
	/*019*/	 "DeleteProperty",
	/*020*/	 "GetProperty",
	/*021*/	 "ListProperties",
	/*022*/	 "SetSelectionOwner",
	/*023*/	 "GetSelectionOwner",
	/*024*/	 "ConvertSelection",

	/*025*/	 "SendEvent",
	/*026*/	 "GrabPointer",
	/*027*/	 "UngrabPointer",
	/*028*/	 "GrabButton",	
	/*029*/	 "UngrabButton",
	/*030*/	 "ChangeActivePointerGrab",
	/*031*/	 "GrabKeyboard",
	/*032*/	 "UngrabKeyboard",
	/*033*/	 "GrabKey",
	/*034*/	 "UngrabKey",
	/*035*/	 "AllowEvents",
	/*036*/	 "GrabServer",
	/*037*/	 "UngrabServer",
	/*038*/	 "QueryPointer",
	/*039*/	 "GetMotionEvents",
	/*040*/	 "TranslateCoordinates",
	/*041*/	 "WarpPointer",
	/*042*/	 "SetInputFocus",
	/*043*/	 "GetInputFocus",
	/*044*/	 "QueryKeymap",
	/*045*/	 "OpenFont",

	/*046*/	 "CloseFont",
	/*047*/	 "QueryFont",
	/*048*/	 "QueryTextExtents",
	/*049*/	 "ListFonts",
	/*050*/	 "ListFontsWithInfo",
	/*051*/	 "SetFontPath",	
	/*052*/	 "GetFontPath",

	/*053*/	 "CreatePixmap",
	/*054*/	 "FreePixmap",
	/*055*/	 "CreateGC",
	/*056*/	 "ChangeGC",
	/*057*/	 "CopyGC",
	/*058*/	 "SetDashes",
	/*059*/	 "SetClipRectangles",
	/*060*/	 "FreeGC",

	/*061*/	 "ClearArea",
	/*062*/	 "CopyArea",
	/*063*/	 "CopyPlane",

	/*064*/	 "PolyPoint",
	/*065*/	 "PolyLine",
	/*066*/	 "PolySegment",
	/*067*/	 "PolyRectangle",
	/*068*/	 "PolyArc",
	/*069*/	 "FillPoly",
	/*070*/	 "PolyFillRectangle",
	/*071*/	 "PolyFillArc",	

	/*072*/	 "PutImage",
	/*073*/	 "GetImage",
	/*074*/	 "PolyText8",
	/*075*/	 "PolyText16",
	/*076*/	 "ImageText8",
	/*077*/	 "ImageText16",

	/*078*/	 "CreateColormap",
	/*079*/	 "FreeColormap",
	/*080*/	 "CopyColormapAndFree",
	/*081*/	 "InstallColormap",
	/*082*/	 "UninstallColormap",
	/*083*/	 "ListInstalledColormaps",
	/*084*/	 "AllocColor",	
	/*085*/	 "AllocNamedColor",
	/*086*/	 "AllocColorCells",
	/*087*/	 "AllocColorPlanes",
	/*088*/	 "FreeColors",
	/*089*/	 "StoreColors",
	/*090*/	 "StoreNamedColor",
	/*091*/	 "QueryColors",	
	/*092*/	 "LookupColor",

	/*093*/	 "CreateCursor",
	/*094*/	 "CreateGlyphCursor",
	/*095*/	 "FreeCursor",	
	/*096*/	 "RecolorCursor",

	/*097*/	 "QueryBestSize",
	/*098*/	 "QueryExtension",
	/*099*/	 "ListExtensions",

	/*100*/	 "ChangeKeyboardMapping",
	/*101*/	 "GetKeyboardMapping",	
	/*102*/	 "ChangeKeyboardControl",
	/*103*/	 "GetKeyboardControl",	
	/*104*/	 "Bell",
	/*105*/	 "ChangePointerControl",
	/*106*/	 "GetPointerControl",
	/*107*/	 "SetScreenSaver",
	/*108*/	 "GetScreenSaver",

	/*109*/	 "ChangeHosts",	
	/*110*/	 "ListHosts",
	/*111*/	 "SetAccessControl",
	/*112*/	 "SetCloseDownMode",
	/*113*/	 "KillClient",
	/*114*/	 "RotateProperties",
	/*115*/	 "ForceScreenSaver",
	/*116*/	 "SetPointerMapping",

	/*117*/	 "GetPointerMapping",
	/*118*/	 "SetModifierMapping",
	/*119*/	 "GetModifierMapping",

        /*120*/  "PopUpInfo",        
	/*121*/	 "NOT DEFINED",	
	/*122*/	 "NOT DEFINED",
	/*123*/	 "NOT DEFINED",
	/*124*/	 "NOT DEFINED",
	/*125*/	 "NOT DEFINED",
	/*126*/	 "NOT DEFINED",
	/*127*/	 "NoOperation",
	/*128*/	 "Error Usage",
	/*129*/	 "Error Usage"
};


