/*
 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

  
/*
	misc.h
	Declaraions for miscellaneous routines in misc.c

*/

#ifndef MISC__H
#define MISC__H

#include <X11/X.h>	/* For LSBFirst & MSBFirst */
#include <X11/Xmd.h>	/* For type definitions */

#define	INITIAL_MSG	"Welcome to XTV -- X Teleconferencing and Viewing --\nA Framework for Sharing X Window Clients\n          VERSION 3"

#define	MSB_First	(BYTE)0x42
#define	LSB_First	(BYTE)0x6c

/*
#define	FROMLOCAL(x)	( LocalByteOrder() == (x) ? (x) : ( (x)==MSB_First ? LSB_First : MSB_First) )
*/
#define FROMLOCAL(x) (x)

void ErrorMessage();
void FatalError();
BYTE LocalByteOrder();
void LGetArgs();
extern void add_pixel_to_list();
/*
 * Begin Murray Addition
 */
void dumpMessageBuffer();
void freeMessageBuffer();
void lockMessages();
void unlockMessages();
/*
 * End Murray Addition
 */
void UpdateMessage();

#define NEEDSWAP 1
#if REPLACED_BY_MACRO     /* FSH 12-7-91 */ 
CARD16 SwapInt();
CARD32 SwapLong();
#else
#define SwapInt(Value, SwapMode)	Value
#define SwapLong(Value, SwapMode)	Value
#endif


  /*
  ** FSH 21-SEP_91 :  Faster swaps via inline macros 
  */
#ifndef LOCBYTEORDER_DEFINED  
  BYTE	LocByteOrder;
#else
  extern BYTE LocByteOrder;
#define LOCBYTEORDER_DEFINED 1  
#endif    

#define SWAP_INT(value,mode) ((mode == LocByteOrder)? value: \
           (( (value & 0x00ff) << 8) | ((value & 0xff00) >> 8)))

#define SWAP_LONG(value,mode) ((mode == LocByteOrder)? value: \
           ( ((value & 0x000000ff) << 24) | ((value & 0x0000ff00) << 8) | \
	     (( value & 0x00ff0000) >> 8 ) | ((value & 0xff000000) >> 24)))

  
#endif /* MISC__H */
