/*
 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

/*
        popups.c

	To create and mange dailogues and popup boxs
*/
#define DEBUGInitializePopUpBox 0&DEBUGON
#define DEBUGPopUpBox 0&DEBUGON

#include <stdio.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Shell.h>
#include <signal.h>

#include "subscriber.h"
#include "tool.h"
#include "network.h"
#include "protocol.h"
#include "token.h"
#include "popups.h"

extern XtCallbackProc ConfirmQuitProc(), CancelQuitProc();
extern XtCallbackProc ConfirmFryTool(), CancelFryTool();
extern XtCallbackProc ConfirmFrySubscriber(), CancelFrySubscriber();
/* extern XtCallbackProc DefaultHost(); */
extern XtCallbackProc DialogDoneHost();
extern XtCallbackProc DialogDoneRemote();
extern XtCallbackProc CancelDone();
extern XtCallbackProc DialogDoneJoinAll();
extern XtCallbackProc DialogDoneJoin();
extern XtCallbackProc JoinCancelDone();
extern BYTE VS;
extern BYTE vs_in_out;


/* begin Ramesh's modification for VS-XTV */

XtCallbackProc DefaultHost();
XtCallbackProc RecordOnHost();
XtCallbackProc RecordOnRemote();
XtCallbackProc PopdownLocal();
XtCallbackProc PopdownRemote();
XtCallbackProc PopdownVSLocal();
XtCallbackProc PopdownVSRemote();

void  PopRecorder(); 
void  DoneOptions();
void  OptionChange();

Widget REpopup, RE_confirm, PEnter_enter;
Widget Join, Resz, Color, Fast, Pstat, Popup, VirScr;

extern BYTE VERBOSE;
extern BYTE JOIN;
extern BYTE POPUP;
extern BYTE XCOLOR;
extern BYTE RESIZE;
extern BYTE SEQNUM;


int ReRemoteFlag = 1;
int ReHostFlag = 0;
int ReFlag;
int recordflag;
int RecordFlag;
char InputFileName[100];
char toolcommand[100];
extern Widget WTool;
extern BYTE VS;
Widget Host, Remote;

/* end VS-XTV modification */


extern Widget          Outer;
extern Widget          TopLevel;
extern Widget          WExit;


Widget TranShell[3];
Widget DialogBox[3];
Widget Confirm[3];
Widget Cancel[3];

String TranShellLabel[]={"TranShellQuit","TranShellTermTool","TranShellDropPart"};
String DialogBoxLabel[]={"QuitDialog","TermToolDialog","DropPartDialog"};
String ConfirmLabel[]={"ConfirmQuit","ConfirmTermTool","ConfirmDropPart"};
String CancelLabel[]={"CancelQuit","CancelTermTool","CancelDropPart"};

XtCallbackProc ConfirmCallbackProc[]={
			(XtCallbackProc)ConfirmQuitProc,
			(XtCallbackProc)ConfirmFryTool,
			(XtCallbackProc)ConfirmFrySubscriber};
XtCallbackProc CancelCallbackProc[]={
			(XtCallbackProc)CancelQuitProc,
			(XtCallbackProc)CancelFryTool,
			(XtCallbackProc)CancelFrySubscriber};

Widget      TranShellQuit, QuitDialog, ConfirmQuit, CancelQuit;
Widget      TranShellTermTool, TermToolDialog, ConfirmTermTool, CancelTermTool;
Widget      TranShellDropPart, DropPartDialog, ConfirmDropPart, CancelDropPart;

Widget      TranShellNewTool, NewToolDialog;

Widget	    TranShellJoinTool, WJoinParent, JoinToolLabel, JoinToolViewPort, JoinToolList;

		
/* -------------------------------------------------------------- ----------------------------- */

/*
 *   InitializePopUpBox()
 *
 *   Initialize all work related to PopUpBox button
 *
 */

void InitializePopUpBox(i)
BYTE i;
{

#   if DEBUGInitializePopUpBox
   fprintf( stderr, "InitializePopUpBox(): %s, %s, %s, %s\n",
	TranShellLabel[i], DialogBoxLabel[i], CancelLabel[i], ConfirmLabel[i] );
#   endif

   TranShell[i] = XtCreatePopupShell(
       TranShellLabel[i],
       transientShellWidgetClass,
       TopLevel,
       NULL,
       0
       );

   DialogBox[i] = XtCreateManagedWidget(
       DialogBoxLabel[i],
       boxWidgetClass,
       TranShell[i],
       NULL,
       0
       );

   Confirm[i]     = XtCreateManagedWidget(
       ConfirmLabel[i],
       commandWidgetClass,
       DialogBox[i],
       NULL,
       0
       );
XtAddCallback(Confirm[i], XtNcallback, ConfirmCallbackProc[i], TranShell[i]);

   Cancel[i] = XtCreateManagedWidget(
       CancelLabel[i],
       commandWidgetClass,
       DialogBox[i],
       NULL,
       0
       );

XtAddCallback(Cancel[i], XtNcallback, CancelCallbackProc[i], TranShell[i]);



#   if DEBUGInitializePopUpBox
   fprintf( stderr, "InitializePopUpBox(): Done.\n" );
#   endif

}

/* ---------------------------------------------------------------------------------- */

/*
 *   PopUpBox()
 *
 *   To PopUp a dialoge box in the center of the main panel
 *
 */

XtCallbackProc PopUpBox( widget, transhell, callData)
Widget widget, transhell;
XtPointer  callData;

{

   Dimension width, height;
   Arg arg[2];
   int i;
  int winx, winy;
  int rwinx, rwiny;
  unsigned int maskret;
  Window rootret, childret, root;
   Position x, y;



  /* Get the coordinates of the middle of TopLevel widget */


#       if DEBUGPopUpBox
        fprintf(stderr, "PopUpBox():QueryPointer\n" );
#       endif
  XQueryPointer(XtDisplay(Outer), XtWindow(Outer), &rootret, &childret,
	&rwinx, &rwiny, &winx, &winy, &maskret);



#       if DEBUGPopUpBox
        fprintf(stderr, "PopUpBox():Starting\n" );
#       endif

   i=0;
   XtSetArg(arg[i], XtNwidth, &width);
   i++;
   XtSetArg(arg[i], XtNheight, &height);
   i++;
/*
   XtGetValues(TopLevel, arg, i);
 */

   /*
 * translate coordinates in application top-level window
 * into coordinates from root window origin.
 */
/*
   XtTranslateCoords(TopLevel,
   (Position) width/2,
   (Position) height/2,
   &x, &y);
*/

   i=0;
   XtSetArg(arg[i], XtNx, rwinx);
   i++;
   XtSetArg(arg[i], XtNy, rwiny);
   i++;
   XtSetValues(transhell, arg, i);

#       if DEBUGPopUpBox
        fprintf(stderr, "PopUpBox():about to PopUp\n" );
#       endif
   XtPopup(transhell, XtGrabNonexclusive);
   XBell(XtDisplay(transhell), 10);

#       if DEBUGPopUpBox
        fprintf(stderr, "PopUpBox():finished PopUp\n" );
#       endif
}


/*------------------------------------------------------------------------------------------- */

/*
 *   InitializeNewTool()
 *
 *   Initialize all work related to NewTool button
 *
 */

void InitializeNewTool( AppCon, Parent, Mode )
XtAppContext AppCon;
Widget Parent;
Bool Mode;      /* TRUE if in 'host' mode */
{

   Widget CancelNewTool, Done, Host, Remote, Label;

   static String   DefaultString = "";
   Arg     arg, args[4];
   int     n;
   static XtActionsRec PressHost[] = {
      {"defaultHost", (XtActionProc)DefaultHost}
   };




#   if DEBUGInitializeTool
   fprintf( stderr, "InitializeNewTool()\n" );
#   endif


   TranShellNewTool = XtCreatePopupShell(
       "TranShellNewTool",
       transientShellWidgetClass,
       TopLevel,
       NULL,
       0
       );

   NewToolDialog = XtCreateManagedWidget(
       "NewToolDialog",
       dialogWidgetClass,
       TranShellNewTool,
       NULL,
       0
       );

   Host     = XtCreateManagedWidget(
       "Host",
       commandWidgetClass,
       NewToolDialog,
       NULL,
       0
       );

/* begin Ramesh's modification for VS-XTV */

/* disable VS popup (wahab) */
/*
if (VS)
 XtAddCallback(Host, XtNcallback,RecordOnHost , NewToolDialog);
else
*/
 XtAddCallback(Host, XtNcallback, DialogDoneHost, NewToolDialog); 

/* end VS-XTV modification */

   Remote   =  XtCreateManagedWidget(
       "Remote",
       commandWidgetClass,
       NewToolDialog,
       NULL,
       0
       );

/* begin Ramesh's modification for VS-XTV */

/* disable VS popup (wahab) */

/*
if (VS)
 XtAddCallback(Remote, XtNcallback, RecordOnRemote, NewToolDialog);
else
*/
 XtAddCallback(Remote, XtNcallback, DialogDoneRemote, NewToolDialog); 

/* end VS-XTV modification */ 


   CancelNewTool = XtCreateManagedWidget(
       "CancelNewTool",
       commandWidgetClass,
       NewToolDialog,
       NULL,
       0
       );

   /* Defaults (i.e. no option on command line):
    *
    *  JOIN    = 1  late joiners get tools
    *  RESIZE  = 1  allow resizing of tools
    *  SEQNUM  = 1  use circualr que
    *  XCOLOR  = 1  do color translations
    *  POPUP  = 1  do auto size adjustments
    *  VERBOSE = 1  show statistics on X traffic
    *  VS = 0  tool is outside Virtual Screen
    *
    *  FAST    = -J -Z -C -P -O 0 -V -Q
    */
   Option.j = !JOIN;
   Option.z = !RESIZE;
   Option.q = !SEQNUM;
   Option.c = !XCOLOR;
   Option.p = !POPUP;
   Option.o = !VERBOSE;
   Option.v = !VS;
 
if (VS)
   Option.f = Option.c && Option.j && Option.p && Option.z && Option.q && Option.o && Option.v;
else
   Option.f = Option.c && Option.j && Option.p && Option.z && Option.q && Option.o;

   Label = XtCreateManagedWidget(
       "Label",
       labelWidgetClass,
       NewToolDialog,
       NULL,
       0
       );
   n = 0;
   XtSetArg(args[n], XtNfromVert, Host);n++;
   XtSetArg(args[n], XtNfromHoriz, NULL);n++;
   XtSetValues(Label, args, n);

   Join = XtCreateManagedWidget(
       "Join",
       toggleWidgetClass,
       NewToolDialog,
       NULL,
       0
       );
   n = 0;
   XtSetArg(args[n], XtNfromVert, Label);n++;
   XtSetArg(args[n], XtNfromHoriz, NULL);n++;
   XtSetArg(args[n], XtNstate, Option.j);n++;
   XtSetValues(Join, args, n);
   XtAddCallback(Join, XtNcallback, OptionChange, 'J');

   Resz = XtCreateManagedWidget(
       "Resz",
       toggleWidgetClass,
       NewToolDialog,
       NULL,
       0
       );
   n = 0;
   XtSetArg(args[n], XtNfromVert, Label);n++;
   XtSetArg(args[n], XtNfromHoriz,Join);n++;
   XtSetArg(args[n], XtNstate, Option.z);n++;
   XtSetValues(Resz, args, n);
   XtAddCallback(Resz, XtNcallback, OptionChange, 'Z');

   Color = XtCreateManagedWidget(
       "Color",
       toggleWidgetClass,
       NewToolDialog,
       NULL,
       0
       );
   n = 0;
   XtSetArg(args[n], XtNfromVert, Label);n++;
   XtSetArg(args[n], XtNfromHoriz, Resz);n++;
   XtSetArg(args[n], XtNstate, Option.c);n++;
   XtSetValues(Color, args, n);
   XtAddCallback(Color, XtNcallback, OptionChange, 'C');

   VirScr = XtCreateManagedWidget(
       "VirScr",
       toggleWidgetClass,
       NewToolDialog,
       NULL,
       0
       );
   n = 0;
   XtSetArg(args[n], XtNfromVert, Join);n++;
   XtSetArg(args[n], XtNfromHoriz, NULL);n++;
   XtSetArg(args[n], XtNstate, Option.v);n++;
  if ( VS )
    {
      XtSetArg(args[n],XtNsensitive, True ); n++ ;
    }
  else
    {
      XtSetArg(args[n],XtNsensitive, False ); n++ ;
    }
   XtSetValues(VirScr, args, n);
   XtAddCallback(VirScr, XtNcallback, OptionChange, 'V');

   Pstat = XtCreateManagedWidget(
       "Pstat",
       toggleWidgetClass,
       NewToolDialog,
       NULL,
       0
       );
   n = 0;
   XtSetArg(args[n], XtNfromVert, Resz);n++;
   XtSetArg(args[n], XtNfromHoriz, VirScr);n++;
   XtSetArg(args[n], XtNstate, Option.o);n++;
   XtSetValues(Pstat, args, n);
   XtAddCallback(Pstat, XtNcallback, OptionChange, 'O');

   Popup = XtCreateManagedWidget(
       "Popup",
       toggleWidgetClass,
       NewToolDialog,
       NULL,
       0
       );
   n = 0;
   XtSetArg(args[n], XtNfromVert, Color);n++;
   XtSetArg(args[n], XtNfromHoriz, Pstat);n++;
   XtSetArg(args[n], XtNstate, Option.p);n++;
   XtSetValues(Popup, args, n);
   XtAddCallback(Popup, XtNcallback, OptionChange, 'P');


   Fast = XtCreateManagedWidget(
       "Fast",
       toggleWidgetClass,
       NewToolDialog,
       NULL,
       0
       );
   n = 0;
   XtSetArg(args[n], XtNfromVert, Pstat);n++;
   XtSetArg(args[n], XtNfromHoriz, VirScr);n++;
   XtSetArg(args[n], XtNstate, Option.f);n++;
   XtSetValues(Fast, args, n);
   XtAddCallback(Fast, XtNcallback, OptionChange, 'F');


   XtAddCallback(CancelNewTool, XtNcallback, CancelDone, 0);

   XtSetArg(arg, XtNvalue, DefaultString);
   XtSetValues(NewToolDialog, &arg, 1);
   XtAppAddActions(GetAppCon(), PressHost, XtNumber(PressHost));



#   if DEBUGInitializeTool
   fprintf( stderr, "InitializeNewTool(): Done.\n" );
#   endif
}


/*
 *
 * OptionChange()
 *
 * toggle states of options
 *
 */
void OptionChange(w, option)
Widget w;
char option;
{
  int  n;
  Arg  args[1];

  switch (option){
    case 'J':
      if(Option.j)
        Option.j = 0;
      else
        Option.j = 1;      /* invoke -J */
      break;
    case 'Z':
      if(Option.z)
        Option.z = 0;
      else
        Option.z = 1;      /* invoke -Z */
      break;
    case 'Q':
      if(Option.q)
        Option.q = 0;
      else
        Option.q = 1;      /* invoke -Q */
      break;
    case 'C':
      if(Option.c)
        Option.c = 0;
      else
        Option.c = 1;      /* invoke -C */
      break;
    case 'F':
      if(Option.f){
        Option.c = 0;      /* make not FAST by not invoking -J -Z -Q -C -O 0 -P -V */
        Option.j = 0;
        Option.p = 0;
        Option.z = 0;
        Option.q = 0;
        Option.o = 0;
        Option.v = !VS;
      }
      else{
        Option.c = 1;      /* make FAST by invoking -J -Z -C -O 0 -P -V */
        Option.j = 1;
        Option.p = 1;
        Option.z = 1;
        Option.q = 1;
        Option.o = 1;
        Option.v = 1;
      }
      n = 0;
      XtSetArg(args[n], XtNstate, Option.c );n++;
      XtSetValues(Color, args, n);
      n = 0;
      XtSetArg(args[n], XtNstate, Option.j );n++;
      XtSetValues(Join, args, n);
      n = 0;
      XtSetArg(args[n], XtNstate, Option.p );n++;
      XtSetValues(Popup, args, n);
      n = 0;
      XtSetArg(args[n], XtNstate, Option.z );n++;
      XtSetValues(Resz, args, n);
      n = 0;
      XtSetArg(args[n], XtNstate, Option.o );n++;
      XtSetValues(Pstat, args, n);
      n = 0;
      XtSetArg(args[n], XtNstate, Option.v );n++;
      XtSetValues(VirScr, args, n);
      break;
    case 'O':
      if(Option.o)
        Option.o = 0;
      else
        Option.o = 1;      /* invoke -O 0 */
      break;
    case 'P':
      if(Option.p)
        Option.p = 0;
      else
        Option.p = 1;      /* invoke -P */
      break;
    case 'V':
      if(Option.v)
        Option.v = 0;
      else
        Option.v = 1;      /* invoke -V */
      break;

  }
  /* recalculate the state of FAST */

if (VS)
   Option.f = Option.c && Option.j && Option.p && Option.z && Option.q && Option.o && Option.v;
else
   Option.f = Option.c && Option.j && Option.p && Option.z && Option.q && Option.o;
  n = 0;
  XtSetArg(args[n], XtNstate, Option.f );n++;
  XtSetValues(Fast, args, n);
}


/*
 *   InitializeJoinTool()
 *
 *   Initialize all work related to JoinTool button
 *
 */
void InitializeJoinTool( AppCon, Parent )
XtAppContext AppCon;
Widget Parent;
{
       Widget WJoinAllTools, WJoinTool, WJoinCancel;

        TranShellJoinTool = XtCreatePopupShell(
                "TranShellJoinTool",
                transientShellWidgetClass,
                TopLevel,
                NULL,
                0
                );

        WJoinParent = XtCreateManagedWidget(
                "JoinParent",
                formWidgetClass,
                TranShellJoinTool,
                NULL,
                0
                );

        JoinToolLabel = XtCreateManagedWidget(
                "JoinToolLabel",
                labelWidgetClass,
                WJoinParent,
                NULL,
                0
                );

        JoinToolViewPort = XtCreateManagedWidget(
                "JoinToolViewPort",
                viewportWidgetClass,
                WJoinParent,
                NULL,
                0
                );

        JoinToolList = XtCreateManagedWidget(
                "JoinToolList",
                listWidgetClass,
                JoinToolViewPort,
                NULL,
                0
                );

        WJoinTool = XtCreateManagedWidget(
                "WJoinTool",
                commandWidgetClass,
                WJoinParent,
                NULL,
                0
                );

        XtAddCallback(WJoinTool, XtNcallback, DialogDoneJoin, TranShellJoinTool)
;

        WJoinCancel = XtCreateManagedWidget(
                "WJoinCancel",
                commandWidgetClass,
                WJoinParent,
                NULL,
                0
                );

        XtAddCallback(WJoinCancel, XtNcallback, JoinCancelDone, 0);

	WJoinAllTools = XtCreateManagedWidget(
		"WJoinAllTools",
		commandWidgetClass,
		WJoinParent,
		NULL,
		0
		);

	XtAddCallback(WJoinAllTools, XtNcallback, DialogDoneJoinAll, 0);
}

void InitializeAllPopUps()
{
InitializePopUpBox(Quit);

InitializePopUpBox(TermTool);

InitializePopUpBox(DropPart);
}


/* begin Ramesh's modification for VS-XTV */

/*
 *
 * DefaultHost()
 *
 * An action proc called when Return is pressed
 *
 */
XtCallbackProc DefaultHost(w, event)
Widget w;
XButtonEvent *event;
{
   /* What an imitation !, violation of OOP !! */
/* disable VS popup (wahab) */
/*
   if (VS)
   	RecordOnHost(w, NewToolDialog, NULL);
   else
*/
   	DialogDoneHost(w, NewToolDialog, NULL);
}

XtCallbackProc RecordOnHost(w,parent,call_data)
Widget w;
Widget parent;
XtPointer call_data;
{


    ReHostFlag = 1;
    PopRecorder(w, parent, ReHostFlag);
  }

XtCallbackProc RecordOnRemote(w,parent,call_data)
Widget w;
Widget parent;
XtPointer call_data;

{


    ReHostFlag = 0;
    PopRecorder(w, parent, ReRemoteFlag);
  }


void PopRecorder(w,parent,ReFlag)
Widget w ;
Widget parent;
int ReFlag;
{
  
  Widget RE_form,
  RE_quit;
  Position x,y;
  Dimension width,heigth;
  Arg  arg[2];
  
  
  REpopup= XtVaCreatePopupShell("Rpopup",transientShellWidgetClass,
                      parent,NULL);
  RE_form = XtVaCreateManagedWidget("Rpopup_form",
				    formWidgetClass,
				    REpopup ,
				    NULL);
  RE_confirm = XtVaCreateManagedWidget("REconfirm",commandWidgetClass,
				       RE_form,
				       XtNlabel,"Inside VirtualScreen",
				       NULL) ;
  RE_quit = XtVaCreateManagedWidget("quit",commandWidgetClass,
				    RE_form,
				    XtNfromVert,RE_confirm,
				    XtNlabel,"Outside VirtualScreen",
				    NULL) ;

  XtVaGetValues( parent ,XtNwidth,&width,
                  XtNheight,&heigth,NULL);
  XtTranslateCoords( parent ,(Position) width-100,
                            (Position) heigth-100,
                            &x,&y);
  XtVaSetValues(REpopup,XtNx,x,XtNy,y,NULL);
  XtSetSensitive(w,False);
  XtPopup(REpopup,XtGrabNonexclusive);
  XBell(XtDisplay(REpopup), 10);
  if (ReHostFlag){
    XtSetSensitive(w,TRUE);
    XtAddCallback(RE_confirm,XtNcallback,PopdownVSLocal,NewToolDialog);
    XtAddCallback(RE_quit,XtNcallback,PopdownLocal,NewToolDialog);
  }
  else 
     {
       XtSetSensitive(w,TRUE);
       XtAddCallback(RE_confirm,XtNcallback,PopdownVSRemote,NewToolDialog);
       XtAddCallback(RE_quit,XtNcallback,PopdownRemote,NewToolDialog);
     }
}


XtCallbackProc PopdownLocal(w,parent,call_data)
Widget w;
Widget parent;
XtPointer call_data;
{

  vs_in_out = 0;
  XtPopdown(REpopup); 
  DialogDoneHost(w,parent,call_data);
}


XtCallbackProc PopdownRemote(w,parent,call_data)
Widget w;
Widget parent;
XtPointer call_data;
{
  vs_in_out = 0;
  XtPopdown(REpopup);
  DialogDoneRemote(w,parent,call_data);
}

XtCallbackProc PopdownVSLocal(w,parent,call_data)
Widget w;
Widget parent;
XtPointer call_data;
{
  vs_in_out = 1;
  XtPopdown(REpopup); 
  DialogDoneHost(w,parent,call_data);
}


XtCallbackProc PopdownVSRemote(w,parent,call_data)
Widget w;
Widget parent;
XtPointer call_data;
{
  vs_in_out = 1;
  XtPopdown(REpopup); 
  DialogDoneRemote(w,parent,call_data);
}


/* end VS-XTV modification */

void SetPlace(w, top)
Widget w;
Widget top;
{
   int      winx, winy, rwinx, rwiny;
   unsigned int    maskret;
   Window       rootret, childret;
   Arg       arg[2];

   XQueryPointer(XtDisplay(top), XtWindow(top), &rootret,
   &childret, &rwinx, &rwiny, &winx, &winy, &maskret);

   /* move the popup shell to pointer position */
   XtSetArg(arg[0], XtNx, rwinx);
   XtSetArg(arg[1], XtNy, rwiny+20);
   XtSetValues(w, arg, 2);
}

void SetPlaceWindow(w, top)
Window w;
Widget top;
{
   int      winx, winy, rwinx, rwiny;
   unsigned int    maskret;
   Window       rootret, childret;
   unsigned int vmask;
   XWindowChanges values;

   Arg       arg[2];

   XQueryPointer(XtDisplay(top), XtWindow(top), &rootret,
   &childret, &rwinx, &rwiny, &winx, &winy, &maskret);

   /* move the popup shell to pointer position */
/*
   XMoveWindow(XtDisplay(top), w, rwinx, rwiny+20);
*/
   vmask = CWX|CWY ;
   values.x = rwinx;
   values.y = rwiny+20;
   XConfigureWindow(XtDisplay(top), w,CWX|CWY ,&values);
}

